import React from 'react';

function preload(Component) {
  if (!('contextTypes' in Component)) {
    Component.contextTypes = {};
  }
  Object.assign(Component.contextTypes, {
    preload: React.PropTypes.bool
  });
  const _componentWillMount = Component.prototype.componentWillMount;
  Component.prototype.componentWillMount = function componentWillMount () {
    if (this.context.preload === true && typeof this.preload === 'function') {
      this.preload.apply(this, arguments);
    }
    if (typeof _componentWillMount === 'function') {
      _componentWillMount.apply(this, arguments);
    }
  }
}

export default preload;